package sets;


import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;


// lockable node, whose next field can be read without locking
class ReadWriteNode<T> extends BasicNode<T>
{
    private volatile Node<T> next;  // next node in chain

    public Node<T> next() {
        return this.next;
    }

    public void setNext(Node<T> next) {
        this.next = next;
    }

    Lock lock = new ReentrantLock();

    @Override
    public void lock() {
        lock.lock();
    }

    @Override
    public void unlock() {
        lock.unlock();
    }

    ReadWriteNode(T item) {
        super(item);
    }

    ReadWriteNode(int key) {
        super(key);
    }
}
